<?php
namespace Financeiro\Logic\ContasReceber\Cnab\Remessa;

use \Financeiro\Entities\Boletreceber;
use \Financeiro\Entities\Cnabrec;
use \Financeiro\Logic\ContasReceber\Cnab\Remessa\GeraCnabSantander;
use \Financeiro\Logic\ContasReceber\Cnab\Remessa\GeraCnabBradesco;
use Geral\Entities\Contcorr;
use Geral\Util\Ambiente;
use \Geral\Util\DateUtil;
use \Geral\Util\NovoCodigo;
use Indeterminado\Entities\Logboletoremrec;

class OperacoesCnab
{
    const WINDOW_NAME = 'wzd_stage_pbi00109_001_win_pbi00109_001';
	const ID_STATUS_BOLETO_ENVIADO = '10';

	public static function insereRemessa($caminho, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec,
										 $nrcnabrec, $idoperacao, $cdagenciacnab, $cdcontacorrente, $cdcontcorrcobranca, $nossonumero,
                                         $dtvenbolrec, $cdreducont, $nrcnab, $nrseqremessarec)
	{
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
		try{
            $idopecnabrec = tk_get_context_vars('IDOPECNABREC', 'wzd_stage_pbi00109_001_win_pbi00109_001');
            $boletos = tk_get_env_var('Boletos');
            $quantidade = count($boletos);
            $valortotal = 0;
            foreach ($boletos as $key => $valor){
            	$valortotal += $valor['VRFINALBREC'];
            }
            $remessa = self::salvaRemessa($quantidade, $valortotal, $caminho, $nrcnab, $nrseqremessarec);
            self::alteraBoletos($boletos, $remessa->getNrcnabrec());
            $nmarquivo = "CNABREC$cdempresa$nrcnab.txt";
            switch($cdbanco){
                case '033':
                    $emiteremessa = GeraCnabSantander::factory($remessa);
                    if (count($boletos) != 0){
                        $emiteremessa->geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(), $remessa->getNrcnabrec(), $cdreducont);
                        $emiteremessa->geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(), $remessa->getNrcnabrec(), $cdreducont);

                        foreach ($boletos as $boleto) {
                            $emiteremessa->geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(),
                                $nrcnabrec, $idoperacao, $boleto['CDAGENCIA'], $cdcontacorrente, $cdcontcorrcobranca, $boleto['CDNOSNUMREC'],
                                $boleto['IDCARTCOBREC'], $boleto['NRLANBOLREC'], $boleto['CDFILIAL'], $boleto['DTVENBOLREC'], $boleto['VRFINALBREC'], $boleto['VRPEMORBREC'], $boleto['VRMORDIABREC'],
                                $boleto['VRPEMULBREC'], $boleto['VRMULTABREC'], $boleto['VRFINALBREC'], $boleto['CDCARTCOBBOL'], $boleto['CDDIAPROTBOL'], $cdreducont,  $boleto['IDIMPRBOLBOL'],
                                $boleto['QTDIAPROTBOL']
                            );
                            $emiteremessa->geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $boleto['CDCLIENTE'], $idoperacao, $cdempresa, $boleto['CDFILIAL'], $boleto['NRLANBOLREC']);
                            $emiteremessa->geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $boleto['DTVENBOLREC'], $boleto['VRPEMULBREC'], $boleto['NRLANBOLREC'], $boleto['VRMULTABREC']);
                        }
                        $emiteremessa->GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco);
                        $emiteremessa->GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco);
                    }
                break;
                case '237':
                    $emiteremessa = GeraCnabBradesco::factory($remessa);
                    if(count($boletos) != 0){
                        $emiteremessa->geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(), $remessa->getNrcnabrec(), $cdreducont);
                        foreach($boletos as $boleto){
                            $emiteremessa->geraTransacao($caminho, $nmarquivo, $cdempresa, $boleto['CDCARTCOBBOL'], $boleto['CDAGENCIA'], $boleto['CDCONTCORR'],
                                $boleto['CDFILIAL'], $boleto['NRLANBOLREC'], $boleto['VRPEMORBREC'], $boleto['IDIMPRBOLBOL'], $boleto['CDNOSNUMREC'], $boleto['DTVENBOLREC'],
                                $boleto['CDINS1COBBOL'], $boleto['QTDIAPROTBOL'], $boleto['VRMORDIABREC'], $boleto['VRFINALBREC'], $idopecnabrec,
                                $boleto['VRPEMULBREC'], $boleto['IDTPIJURCLIE'], $boleto['NRINSJURCLIE'], $boleto['CDCLIENTE'], $boleto['CDINS2COBBOL']
                            );
                        }
                        $emiteremessa->GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco);
                    }
                break;
                case '341':
                    $emiteremessa = GeraCnabItau::factory($remessa);
                    if(count($boletos) != 0){
                        $emiteremessa->geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont);
                        foreach($boletos as $boleto){
                            $emiteremessa->geraTransacao($caminho, $nmarquivo, $cdempresa, $boleto['CDCARTCOBBOL'], $boleto['CDAGENCIA'], $boleto['CDCONTCORR'],
                                $boleto['CDFILIAL'], $boleto['NRLANBOLREC'], $boleto['VRPEMORBREC'], $boleto['IDIMPRBOLBOL'], $boleto['CDNOSNUMREC'], $boleto['DTVENBOLREC'],
                                $boleto['CDINS1COBBOL'], $boleto['QTDIAPROTBOL'], $boleto['VRMORDIABREC'], $boleto['VRFINALBREC'], $idopecnabrec,
                                $boleto['VRPEMULBREC'], $boleto['IDTPIJURCLIE'], $boleto['NRINSJURCLIE'], $boleto['CDCLIENTE'], $boleto['CDINS2COBBOL']
                            );
                        }
                        $emiteremessa->GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco);
                    }
                    break;
                case '001':
                    $emiteremessa = GeraCnabBrasil::factory($remessa);
                    if(count($boletos) != 0){
                        $emiteremessa->geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont, $boletos[$key]['CDCARTCOBBOL']);
                        $emiteremessa->geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(), $remessa->getNrcnabrec(), $cdreducont, $boletos[$key]['CDCARTCOBBOL']);
                        foreach ($boletos as $boleto) {
                            $emiteremessa->geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(),
                                $nrcnabrec, $idoperacao, $boleto['CDAGENCIA'], $cdcontacorrente, $cdcontcorrcobranca, $boleto['CDNOSNUMREC'],
                                $boleto['IDCARTCOBREC'], $boleto['NRLANBOLREC'], $boleto['CDFILIAL'], $boleto['DTVENBOLREC'], $boleto['VRFINALBREC'], $boleto['VRPEMORBREC'], $boleto['VRMORDIABREC'],
                                $boleto['VRPEMULBREC'], $boleto['VRMULTABREC'], $boleto['VRFINALBREC'], $boleto['CDCARTCOBBOL'], $boleto['CDDIAPROTBOL'], $cdreducont,  $boleto['IDIMPRBOLBOL'],
                                $boleto['QTDIAPROTBOL']
                            );
                            $emiteremessa->geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $boleto['CDCLIENTE'], $idoperacao, $cdempresa, $boleto['CDFILIAL'], $boleto['NRLANBOLREC']);
                            if(trim($boleto['TXMENSBOLBOL']) or $boleto['VRPEMULBREC'] != 0 or $boleto['VRMULTABREC'] != 0)
                                $emiteremessa->geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $boleto['DTVENBOLREC'], $boleto['VRPEMULBREC'], $boleto['NRLANBOLREC'], $boleto['VRMULTABREC']);
                        }
                        $emiteremessa->GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco);
                        $emiteremessa->GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco);
                    }
                    break;
                case '104':
                    $emiteremessa = GeraCnabCaixa::factory($remessa);
                    if(count($boletos) != 0){
                        $emiteremessa->geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont);
                        $emiteremessa->geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(), $remessa->getNrcnabrec(), $cdreducont);
                        foreach ($boletos as $boleto) {
                            $emiteremessa->geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $remessa->getNrseqremessarec(),
                                $nrcnabrec, $idoperacao, $boleto['CDAGENCIA'], $cdcontacorrente, $cdcontcorrcobranca, $boleto['CDNOSNUMREC'],
                                $boleto['IDCARTCOBREC'], $boleto['NRLANBOLREC'], $boleto['CDFILIAL'], $boleto['DTVENBOLREC'], $boleto['VRFINALBREC'], $boleto['VRPEMORBREC'], $boleto['VRMORDIABREC'],
                                $boleto['VRPEMULBREC'], $boleto['VRMULTABREC'], $boleto['VRFINALBREC'], $boleto['CDCARTCOBBOL'], $boleto['CDDIAPROTBOL'], $cdreducont,  $boleto['IDIMPRBOLBOL'],
                                $boleto['QTDIAPROTBOL']
                            );
                            $emiteremessa->geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $boleto['CDCLIENTE'], $idoperacao, $cdempresa, $boleto['CDFILIAL'], $boleto['NRLANBOLREC']);
                            $emiteremessa->geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $boleto['DTVENBOLREC'], $boleto['VRPEMULBREC'], $boleto['NRLANBOLREC'], $boleto['VRMULTABREC']);
                        }
                        $emiteremessa->GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco);
                        $emiteremessa->GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco);
                    }
                    break;
            }

            tk_set_env_var('CONTADOR', 0);
            tk_set_env_var('REGISTROS', 0);
            tk_set_env_var('LOTES', 0);
            tk_set_env_var('NMARQUIVO_CNAB', $remessa->getNrcnabrec());
            $connection->flush();
            $connection->commit();
		}
		catch(\Exception $e){
            $connection->rollback();
		    throw $e;
		}
	}

    /**
     * @param $boleto
     * @param $nrcnabpag
     * @param $cdempresa
     */
    public static function insereLogBoletoRem($boleto, $nrcnabrec, $cdempresa){

        $log = New Logboletoremrec();
        $log->setNrorg(\Ambiente::getNrorg());
        $log->setCdfiliallogrec($boleto['CDFILIAL']);
        $log->setNrlanbolreclog($boleto['NRLANBOLREC']);
        $log->setCdopelogrec(\Ambiente::getCdOperador());
        $log->setNrcnabrecretlog($nrcnabrec);
        $log->setCdempresalogrec($cdempresa);
        $log->setDtinclusao(DateUtil::getDataAtual());
        $log->setDtlogboletrrec(DateUtil::getDataAtual());
        $log->persist();
    }
	
	private static function salvaRemessa($quantidade, $valortotal, $caminho, $nrcnabrec, $nrseqremessarec){
        try {

            $remessa = new Cnabrec();
            $remessa->setCdempresa(tk_get_context_vars('CDEMPRESA', self::WINDOW_NAME));
            $data = self::formataDataCnab(DateUtil::getDataAtual());
            $remessa->setDtcnabrec($data);
            $remessa->setIdopecnabrec(tk_get_context_vars('IDOPECNABREC', self::WINDOW_NAME));
            $remessa->setNrcnabrec($nrcnabrec);
            $remessa->setCdoperador(tk_get_context_vars('CDOPERADOR', self::WINDOW_NAME));
            $remessa->setCdreducont(tk_get_context_vars('CDREDUCONT', self::WINDOW_NAME));
            $remessa->setCdreducontcobr(tk_get_context_vars('CDREDUCONTCOBR', self::WINDOW_NAME));
            $remessa->setIdtipcnabrec('0');
            $empresa = tk_get_context_vars('CDEMPRESA', 'wzd_stage_pbi00109_001_win_pbi00109_001');
            $nmarquivo = "CNABREC$empresa$nrcnabrec.txt";
            $remessa->setDsarqcnabrec($caminho.$nmarquivo);
            $remessa->setNrseqremessarec($nrseqremessarec);
            $remessa->setNrorg(tk_get_context_vars('NRORG', self::WINDOW_NAME));
            $remessa->setQtbolenvcnabrec($quantidade);
            $remessa->setVrtotbolcnabrec($valortotal);
            $remessa->setDtinclusao(DateUtil::getDataAtual());
            $remessa->setIdativo('S');
            $remessa->setNrorg(Ambiente::getNrorg());
            $remessa->persist();
            \Setforms2\Shared\Registry::getEntityManager()->flush();
            return $remessa;
        } catch (\Exception $e) {
            throw $e;
        }
	}
	
	private static function alteraBoletos($boletos, $nrcnabrec){

        try {
            foreach ($boletos as $boleto) {
                /**@var $boletreceber Boletreceber */
                $boletreceber = Boletreceber::findOneByNrlanbolrecAndCdfilial($boleto['NRLANBOLREC'], $boleto['CDFILIAL']);
                $boletreceber->setNrcnabrecrem($nrcnabrec);
                $boletreceber->persist();
                \Setforms2\Shared\Registry::getEntityManager()->flush();
            }
        } catch (\Exception $e) {
            throw $e;
        }
	}

    public static function formataData($data){
        if(strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function formataDataCnab($data){
        if(strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
//        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function valida_boleto(){
        try {
            $boletos = tk_get_checked_rows();
            $qtde = count($boletos);
            $entrou = false;
            $qtde_venc = 0;
            for ($i = 0; $i < $qtde; $i++) {
                $dtvencimento = self::formataData($boletos[$i]['DTVENBOLREC']);
                $now = self::formataData(now());
                if (DateUtil::comparaDatas($now, $dtvencimento, 2)){
                    unset($boletos[$i]);
                    $entrou = true;
                    $qtde_venc++;
                }
            }
            tk_set_env_var('Boletos', $boletos);
            if ($qtde_venc == $qtde)
                throw new \Exception(tk_get_message_by_name('msg_pbi00109_boletos_vencidos'));
            if ($entrou)
                self::msg_valida_boleto();
            else
                self::confirmar();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function msg_valida_boleto(){
        $mensagem = ("Os boletos vencidos não serão salvos.\nDeseja confirmar a remessa?");
        $confirma = array(
            "label"=> "Sim",
            "method"=> array("\\Financeiro\\Logic\\ContasReceber\\Cnab\\Remessa\\OperacoesCnab", "confirmar"),
            'params_arr' => array(),
        );
        $cancela = array(
            "label"=> "Não",
            "method"=> array("\\Financeiro\\Logic\\ContasReceber\\Cnab\\Remessa\\OperacoesCnab", "cancelar"),
            'params_arr' => array(),
        );
        tk_confirm($mensagem, $confirma, $cancela);
    }

    public static function cancelar(){

    }

    public static function confirmar()
    {
        try {
            $nrorg = Ambiente::getNrorg();
            $empresa = tk_get_context_vars('CDEMPRESA', 'wzd_stage_pbi00109_001_win_pbi00109_001');
            $caminho = APP_PATH . "/public/Cnab/Recebimento/$nrorg/";
            /** @var $contcorr Contcorr */
            $contcorr = Contcorr::findOneByNrorgAndCdreducont(
                Ambiente::getNrorg(), tk_get_context_vars('CDREDUCONT', 'wzd_stage_pbi00109_001_win_pbi00109_001')
            );
            $banco = $contcorr->getCdbanco();
            $nrcnabrec = NovoCodigo::geraCodigo(
                Ambiente::getNrorg(),
                'CNABREC' . tk_get_context_vars('CDEMPRESA', 'wzd_stage_pbi00109_001_win_pbi00109_001'), 1, 10, false
            );
            $nrseqremessarec = NovoCodigo::geraCodigo(
                Ambiente::getNrorg(),
                'SEQREMESSAREC' . tk_get_context_vars('CDREDUCONT', 'wzd_stage_pbi00109_001_win_pbi00109_001'), 1, 10,
                false
            );
            self::insereRemessa(
                $caminho, Ambiente::getNrorg(),
                $banco,
                tk_get_context_vars('CDEMPRESA', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDIDRECCONTCORR', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('NRSEQREMESSAREC', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('NRCNABREC', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('IDOPECNABREC', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDAGENCIA', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDCONTCORR', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDCONTCORRCOBR', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDNOSNUMREC', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('DTVENBOLREC', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                tk_get_context_vars('CDREDUCONT', 'wzd_stage_pbi00109_001_win_pbi00109_001'),
                $nrcnabrec, $nrseqremessarec
            );
            $nmarquivo = "CNABREC$empresa$nrcnabrec.txt";
            $url = realpath($caminho . $nmarquivo);

            $arquivo = new \TkFile($url);
            $arquivo->download();

            tk_message('Operação realizada com sucesso!', 'success');
            tk_close_wizard('wzd_pbi00109_000');
        } catch (\Exception $e) {
            throw $e;
        }

    }
}