CREATE OR REPLACE PROCEDURE CONTABILIZA_EST_SAIDA(
  P_NRLISTA  IN LISTA.NRLISTA%TYPE)
IS
  V_NRLANCLOTE VARCHAR2(06);
  V_CDLOTE VARCHAR2(20);
  V_IDRETORNA VARCHAR2(01);
  V_IDCONTCCUS VARCHAR2(01);
  V_NRLANCESTQ VARCHAR2(10);
  V_DSHISTPADR VARCHAR2(1000);
  V_CDEMPRESA VARCHAR2(02);
  V_CDHISTPADR VARCHAR2(04);
  V_NRLANCESTQDEV VARCHAR2(10);
BEGIN
   EXCLUI_LANCCONTABIL('04',P_NRLISTA);

   V_NRLANCESTQ := '0';

   FOR C_LISTA IN(
        SELECT SUBSTR(L.CDLISTA,1,4) AS CDFILIAL,SUBSTR(L.CDLISTA,5,10) AS NRLANCESTQ
          FROM LISTA L
         WHERE (L.NRLISTA = P_NRLISTA))LOOP

           FOR C_EST_SAIDA IN
               (SELECT SUM(IT.VRCUSTPROD) AS VRCUSTPROD ,IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.CDCENTCUST, IT.DTLANCMOVI,
                        IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB, IT.CDHISTPADR, IT.NRLANCTONF
                   FROM (SELECT I.CDFILIAL, I.NRLANCESTQ, I.CDFILIMOVI, I.DTLANCMOVI, I.CDPRODMOVI,
                                I.QTLANCTOEST * CUSTO_PRODUTO_LCEST(I.CDFILIMOVI, I.CDPRODMOVI, 3,  DTLANCMOVI, DTLANCMOVI, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE) AS VRCUSTPROD,
                                I.DSLANCESTIT, CONTCTBL_PRODUTO(I.CDPRODUTO,'E',I.CDFILIAL) AS CDCONTCTBL,
                                NVL(NVL(CT.CDCTBPRTPOPECMV,T.CDCTBLTPOPERCMV),CONTCTBL_PRODUTO(I.CDPRODUTO,'M',I.CDFILIAL)) AS CDCONTCTBLDEB,
                                F.CDCENTCUST, T.CDHISTPADR, LE.NRLANCTONF
                           FROM ITLANCTOEST I, TIPOOPERAC T, FILIAL F, LANCTOESTOQ LE, CTBPRDTPOPER CT
                          WHERE (I.IDTIPOMOVI = '4')
                            AND (I.CDFILIAL = C_LISTA.CDFILIAL)
                            AND (I.NRLANCESTQ = C_LISTA.NRLANCESTQ)
                            AND (I.CDTIPOOPER   = T.CDTIPOOPER (+))
                            AND (I.IDENTRSAIDOP = T.IDENTRSAIDOP (+))
                            AND (I.CDLOTEITCTB IS NULL)
                            AND (I.CDFILIMOVI = F.CDFILIAL)
                            AND (I.CDFILIAL = LE.CDFILIAL)
                            AND (I.NRLANCESTQ = LE.NRLANCESTQ)
                            AND (CT.CDPRODUTO (+) = I.CDPRODUTO)
                            AND (CT.IDENTRSAIDOP (+) = I.IDENTRSAIDOP)
                            AND (CT.CDTIPOOPER (+) = I.CDTIPOOPER)) IT
                 GROUP BY IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.DTLANCMOVI,
                          IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB,IT.CDCENTCUST,
                          IT.CDHISTPADR,IT.NRLANCTONF
                 ORDER BY IT.CDFILIAL, SUM(IT.VRCUSTPROD)) LOOP

                BEGIN
                  SELECT CDEMPRESA
                    INTO V_CDEMPRESA
                    FROM FILIAL
                   WHERE FILIAL.CDFILIAL = C_EST_SAIDA.CDFILIAL;
                EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                  V_CDEMPRESA := NULL;
                END;

                IF V_NRLANCESTQ <> C_EST_SAIDA.NRLANCESTQ THEN
                   GERA_LOTECONTABIL(V_CDEMPRESA,'04','',C_EST_SAIDA.CDFILIMOVI,C_EST_SAIDA.DTLANCMOVI,'','',V_CDLOTE,V_NRLANCLOTE);
                END IF;

                BEGIN
                 SELECT MAX(CDHISTPADR)
                   INTO V_CDHISTPADR
                   FROM HISTPADR;
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    V_CDHISTPADR := NULL;
                END;

                V_DSHISTPADR := 'SAIDA ESTOQUE';

                NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_EST_SAIDA.DTLANCMOVI,V_NRLANCLOTE,C_EST_SAIDA.CDCONTCTBL,C_EST_SAIDA.CDHISTPADR,
                             V_DSHISTPADR, ROUND(C_EST_SAIDA.VRCUSTPROD,2),'','','04', C_EST_SAIDA.NRLANCESTQ, 'S');

                BEGIN
                  SELECT IDCONTCCUS
                    INTO V_IDCONTCCUS
                    FROM CONTCTBL
                   WHERE CDCONTCTBL =  C_EST_SAIDA.CDCONTCTBL;
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    V_IDCONTCCUS := NULL;
                END;

                IF V_IDCONTCCUS <> 'O' THEN
                   IF C_EST_SAIDA.CDCENTCUST IS NOT NULL THEN
                      RATEIO_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_EST_SAIDA.DTLANCMOVI,V_NRLANCLOTE,C_EST_SAIDA.CDFILIMOVI,
                                     C_EST_SAIDA.CDCENTCUST,ROUND(C_EST_SAIDA.VRCUSTPROD,2));
                   END IF;
                END IF;

                NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_EST_SAIDA.DTLANCMOVI,V_NRLANCLOTE,C_EST_SAIDA.CDCONTCTBLDEB,C_EST_SAIDA.CDHISTPADR,
                             V_DSHISTPADR, ROUND(C_EST_SAIDA.VRCUSTPROD * -1,2),'','','04', C_EST_SAIDA.NRLANCESTQ,'S');

                BEGIN
                  SELECT IDCONTCCUS
                    INTO V_IDCONTCCUS
                    FROM CONTCTBL
                   WHERE CDCONTCTBL =  C_EST_SAIDA.CDCONTCTBLDEB;
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    V_IDCONTCCUS := NULL;
                END;

                IF V_IDCONTCCUS <> 'O' THEN
                   IF C_EST_SAIDA.CDCENTCUST IS NOT NULL THEN
                      RATEIO_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_EST_SAIDA.DTLANCMOVI,V_NRLANCLOTE,C_EST_SAIDA.CDFILIMOVI,
                                     C_EST_SAIDA.CDCENTCUST,ROUND(C_EST_SAIDA.VRCUSTPROD * -1,2));
                   END IF;
                END IF;

                FOR C_DEV_NF IN (
                    SELECT SUM(IT.VRCUSTPROD) AS VRCUSTPROD ,IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.CDCENTCUST, IT.DTLANCMOVI,
                           IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB, IT.CDHISTPADR, IT.NRLANCTONF
                      FROM (SELECT I.CDFILIAL, I.NRLANCESTQ, I.CDFILIMOVI, I.DTLANCMOVI, I.CDPRODMOVI,
                                   I.QTLANCTOEST * CUSTO_PRODUTO_LCEST(I.CDFILIMOVI, I.CDPRODMOVI, 3,  DTLANCMOVI, DTLANCMOVI, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE) AS VRCUSTPROD,
                                   I.DSLANCESTIT, CONTCTBL_PRODUTO(I.CDPRODUTO,'E',I.CDFILIAL) AS CDCONTCTBL,
                                   NVL(NVL(CT.CDCTBPRTPOPECMV,TP.CDCTBLTPOPERCMV),CONTCTBL_PRODUTO(I.CDPRODUTO,'M',I.CDFILIAL)) AS CDCONTCTBLDEB,
                                   F.CDCENTCUST, TP.CDHISTPADR, LE.NRLANCTONF
                              FROM ITEMNOTAFISC ITNF, NOTAFISCAL NF, TIPOOPERAC TP,
                                   LANCTOESTOQ LE, ITLANCTOEST I, CTBPRDTPOPER CT, FILIAL F
                             WHERE ITNF.CDFILIALIT   = NF.CDFILIAL
                               AND ITNF.NRLANCTONF   = NF.NRLANCTONF
                               AND NF.IDENTRSAIDOP   = TP.IDENTRSAIDOP
                               AND NF.CDTIPOOPER     = TP.CDTIPOOPER
                               AND NF.CDFILIAL       = LE.CDFILIAL
                               AND NF.NRLANCTONF     = LE.NRLANCTONF
                               AND LE.CDFILIAL       = I.CDFILIAL
                               AND LE.NRLANCESTQ     = I.NRLANCESTQ
                               AND (CT.CDPRODUTO (+) = I.CDPRODUTO)
                               AND (CT.IDENTRSAIDOP (+) = I.IDENTRSAIDOP)
                               AND (CT.CDTIPOOPER (+) = I.CDTIPOOPER)
                               AND (I.CDFILIMOVI = F.CDFILIAL)
                               AND ITNF.CDFILIALIT   = C_EST_SAIDA.CDFILIAL
                               AND ITNF.NRLANCTONFIT = C_EST_SAIDA.NRLANCTONF
                               AND TP.IDUTCUSORIGEST = 'S') IT
                     GROUP BY IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.DTLANCMOVI,
                             IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB,IT.CDCENTCUST,
                             IT.CDHISTPADR,IT.NRLANCTONF
                     ORDER BY IT.CDFILIAL, SUM(IT.VRCUSTPROD)) LOOP

                     V_DSHISTPADR := 'DEVOLUO';

                     NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_DEV_NF.DTLANCMOVI,V_NRLANCLOTE,C_DEV_NF.CDCONTCTBL,C_DEV_NF.CDHISTPADR,
                                  V_DSHISTPADR, ROUND(C_DEV_NF.VRCUSTPROD * -1,2),'','','04', C_DEV_NF.NRLANCESTQ, 'N');

                     BEGIN
                       SELECT IDCONTCCUS
                         INTO V_IDCONTCCUS
                         FROM CONTCTBL
                        WHERE CDCONTCTBL =  C_DEV_NF.CDCONTCTBL;
                     EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                         V_IDCONTCCUS := NULL;
                     END;

                     IF V_IDCONTCCUS <> 'O' THEN
                        IF C_EST_SAIDA.CDCENTCUST IS NOT NULL THEN
                           RATEIO_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_DEV_NF.DTLANCMOVI,V_NRLANCLOTE,C_DEV_NF.CDFILIMOVI,
                                          C_DEV_NF.CDCENTCUST,ROUND(C_DEV_NF.VRCUSTPROD,2));
                        END IF;
                     END IF;

                     NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_DEV_NF.DTLANCMOVI,V_NRLANCLOTE,C_DEV_NF.CDCONTCTBLDEB,C_DEV_NF.CDHISTPADR,
                                  V_DSHISTPADR, ROUND(C_DEV_NF.VRCUSTPROD,2),'','','04', C_DEV_NF.NRLANCESTQ,'N');

                     BEGIN
                       SELECT IDCONTCCUS
                         INTO V_IDCONTCCUS
                         FROM CONTCTBL
                        WHERE CDCONTCTBL =  C_DEV_NF.CDCONTCTBLDEB;
                     EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                         V_IDCONTCCUS := NULL;
                     END;

                     IF V_IDCONTCCUS <> 'O' THEN
                        IF C_EST_SAIDA.CDCENTCUST IS NOT NULL THEN
                           RATEIO_PARTIDA(V_CDEMPRESA,V_CDLOTE,C_DEV_NF.DTLANCMOVI,V_NRLANCLOTE,C_DEV_NF.CDFILIMOVI,
                                          C_DEV_NF.CDCENTCUST,ROUND(C_DEV_NF.VRCUSTPROD,2));
                        END IF;
                     END IF;
                END LOOP;

                V_NRLANCESTQ := C_EST_SAIDA.NRLANCESTQ;
           END LOOP;

           IF V_NRLANCESTQ <> '0' THEN
              INSERT INTO RELALESTLANCLOT
                (CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE,CDFILIAL, NRLANCESTQ)
              VALUES
                (V_CDEMPRESA, V_CDLOTE, V_NRLANCLOTE, '00001', C_LISTA.CDFILIAL, C_LISTA.NRLANCESTQ);

              IF CONFERE_PARTIDA(V_CDEMPRESA, V_CDLOTE, V_NRLANCLOTE, '') THEN
                 UPDATE LANCTOESTOQ SET IDSTATUSCTBEST = 'C'
                  WHERE CDFILIAL = C_LISTA.CDFILIAL
                    AND NRLANCESTQ = C_LISTA.NRLANCESTQ;
              ELSE
                 UPDATE LANCTOESTOQ SET IDSTATUSCTBEST = 'E'
                  WHERE CDFILIAL = C_LISTA.CDFILIAL
                    AND NRLANCESTQ = C_LISTA.NRLANCESTQ;
              END IF;
           END IF;
   END LOOP;
   DELETE FROM LISTA
    WHERE NRLISTA = P_NRLISTA;
END;
/
